import unittest
from scannertests import TestPortScannerMethods
from scannertests import TestNetworkScannerMethods
from reportcomparatortests import TestReportComparatorMethods


#def testsuite():
#    test_suite = unittest.TestSuite()
#    test_suite.addTest(unittest.makeSuite(TestNetworkScannerMethods.TestNetworkScannerMethods))
#   test_suite.addTest(unittest.makeSuite(TestPortScannerMethods.TestPortScannerMethods))
#    test_suite.addTest(unittest.makeSuite(TestReportComparatorMethods.TestReportComparatorMethods))
#    return test_suite


#mySuit = testsuite()
#runner = unittest.TextTestRunner()
#runner.run(mySuit)

suite1 = unittest.TestLoader().loadTestsFromTestCase(TestNetworkScannerMethods.TestNetworkScannerMethods)
suite2 = unittest.TestLoader().loadTestsFromTestCase(TestPortScannerMethods.TestPortScannerMethods)
suite3 = unittest.TestLoader().loadTestsFromTestCase(TestReportComparatorMethods.TestReportComparatorMethods)
alltests = unittest.TestSuite([suite1, suite2, suite3])
runner = unittest.TextTestRunner(verbosity=2)
runner.run(alltests)
