import pyautogui
import os
import time
import unittest

# antes de ejecutar los tests, abrir la interfaz de usuario
# requiere una máquina en 192.168.33.20 con el servidor de pruebas 1 y
# otra máquina en 192.168.33.22 con el servidor de pruebas 2


def user_input_scanner(ip, cidr=None, closemozilla=True):
    time.sleep(5)
    pyautogui.moveTo(767, 360)  # ventana scanner
    pyautogui.click()
    pyautogui.moveTo(957, 401)  # input usuario
    pyautogui.click()
    #  delete default imput
    for x in range(30):
        pyautogui.press("backspace")
    pyautogui.write(ip)
    if cidr is not None:
        with pyautogui.hold("shift"):
            pyautogui.press("7")
        pyautogui.write(f"{cidr}")
    pyautogui.moveTo(957, 432)  # botón scan
    pyautogui.click()
    time.sleep(60)  # esperar a que el escaneo se realice y se genere el informe
    if closemozilla:
        pyautogui.moveTo(1868, 46)  # botón minimizar mozilla
        pyautogui.click()


def user_input_comparator(number1, number2, closemozilla=True):
    time.sleep(5)
    pyautogui.moveTo(893, 356)  # ventana comparador
    pyautogui.click()
    pyautogui.moveTo(844, 412)  # ruta 1
    pyautogui.click()
    pyautogui.press("end")
    for x in range(150):
        pyautogui.press("backspace")
    with pyautogui.hold('shift'):
        pyautogui.press('capslock')
        pyautogui.write(f"7home7vagrant7")
        pyautogui.press('capslock')
        pyautogui.write("d")
        pyautogui.press('capslock')
        pyautogui.write("esktop7http")
        pyautogui.press('capslock')
    pyautogui.write("-header-")
    with pyautogui.hold('shift'):
        pyautogui.press('capslock')
        pyautogui.write("evaluator7test7reportcomparatortests7testfiles7scanreporttest")
        pyautogui.press('capslock')
    pyautogui.write(f"{number1}.html")

    pyautogui.moveTo(827, 443)  # ruta 2
    pyautogui.click()
    pyautogui.press("end")
    for x in range(150):
        pyautogui.press("backspace")
    with pyautogui.hold('shift'):
        pyautogui.press('capslock')
        pyautogui.write(f"7home7vagrant7")
        pyautogui.press('capslock')
        pyautogui.write("d")
        pyautogui.press('capslock')
        pyautogui.write("esktop7http")
        pyautogui.press('capslock')
    pyautogui.write("-header-")
    with pyautogui.hold('shift'):
        pyautogui.press('capslock')
        pyautogui.write("evaluator7test7reportcomparatortests7testfiles7scanreporttest")
        pyautogui.press('capslock')
    pyautogui.write(f"{number2}.html")

    pyautogui.moveTo(961, 479)  # botón comparar
    pyautogui.click()
    time.sleep(30)  # esperar a que la comparación se realice y se genere el informe
    if closemozilla:
        pyautogui.moveTo(1868, 46)  # botón minimizar mozilla
        pyautogui.click()


def checks_report_host20(self, filename):
    file = open(os.path.join(self.pathreports, filename))
    filelines = file.readlines()
    self.assertTrue(any(line.__contains__("<h2> Host: 192.168.33.20 </h2>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>CONTENT-SECURITY-POLICY</td> <td class='incorrect-value'>NOT DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>X-FRAME-OPTIONS</td> <td class='incorrect-value'>NOT DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>X-XSS-PROTECTION</td> <td class='incorrect-value'>NOT DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>PUBLIC-KEY-PINS</td> <td class='incorrect-value'>NOT DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>X-CONTENT-TYPE-OPTIONS</td> <td class='correct-value'>DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>STRICT-TRANSPORT-SECURITY</td> <td class='incorrect-value'>NOT DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>EXPECT-CT</td> <td class='incorrect-value'>NOT DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>REFERRER-POLICY</td> <td class='incorrect-value'>NOT DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>FEATURE-POLICY</td> <td class='incorrect-value'>NOT DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>SERVER</td> <td class='correct-value'>DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>CONTENT-TYPE</td> <td class='correct-value'>DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>DATE</td> <td class='correct-value'>DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>CUSTOM-HEADER-HERE</td> <td class='correct-value'>DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>OTRO-CUSTOM</td> <td class='correct-value'>DEFINED</td>") for line in filelines))
    file.close()


def checks_report_host22(self, filename):
    file = open(os.path.join(self.pathreports, filename))
    filelines = file.readlines()
    self.assertTrue(any(line.__contains__("<h2> Host: 192.168.33.22 </h2>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>CONTENT-SECURITY-POLICY</td> <td class='incorrect-value'>NOT DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>X-FRAME-OPTIONS</td> <td class='incorrect-value'>NOT DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>X-XSS-PROTECTION</td> <td class='incorrect-value'>NOT DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>PUBLIC-KEY-PINS</td> <td class='incorrect-value'>NOT DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>X-CONTENT-TYPE-OPTIONS</td> <td class='incorrect-value'>NOT DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>STRICT-TRANSPORT-SECURITY</td> <td class='incorrect-value'>NOT DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>EXPECT-CT</td> <td class='incorrect-value'>NOT DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>REFERRER-POLICY</td> <td class='incorrect-value'>NOT DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>FEATURE-POLICY</td> <td class='incorrect-value'>NOT DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>SERVER</td> <td class='correct-value'>DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>CONTENT-TYPE</td> <td class='correct-value'>DEFINED</td>") for line in filelines))
    self.assertTrue(any(line.__contains__("<td>DATE</td> <td class='correct-value'>DEFINED</td>") for line in filelines))
    file.close()


class TestsSistema(unittest.TestCase):

    dirname = os.path.dirname(__file__)
    pathreports = os.path.join(dirname, "..", "reports")

    def test_scanner_no_hosts(self):
        filesfound = []
        for file in os.listdir(self.pathreports):
            fullpath = os.path.join(self.pathreports, file)
            if os.path.isfile(fullpath):
                filesfound.append(file)

        user_input_scanner('192.168.33.5', closemozilla=False)  # no hay host asignado, no se abrirá mozilla

        newreports = []
        for file in os.listdir(self.pathreports):
            if file not in filesfound:
                newreports.append(file)

        self.assertEqual(len(newreports), 0)  # 0 nuevos informes

    def test_scanner_one_host(self):

        filesfound = []
        for file in os.listdir(self.pathreports):
            fullpath = os.path.join(self.pathreports, file)
            if os.path.isfile(fullpath):
                filesfound.append(file)

        user_input_scanner('192.168.33.20')

        newreports = []
        for file in os.listdir(self.pathreports):
            if file not in filesfound:
                newreports.append(file)

        self.assertEqual(len(newreports), 1)  # 1 nuevo informes

        checks_report_host20(self, newreports[0])

    def test_scanner_two_hosts(self):
        filesfound = []
        for file in os.listdir(self.pathreports):
            fullpath = os.path.join(self.pathreports, file)
            if os.path.isfile(fullpath):
                filesfound.append(file)

        user_input_scanner('192.168.33.16', cidr=28)

        newreports = []
        for file in os.listdir(self.pathreports):
            if file not in filesfound:
                newreports.append(file)

        self.assertEqual(len(newreports), 3)  # 3 nuevos informes

        for report in newreports:
            if report.__contains__("192.168.33.20"):
                checks_report_host20(self, report)
            elif report.__contains__("192.168.33.22"):
                checks_report_host22(self, report)
            else:
                checks_report_host20(self, report)
                checks_report_host22(self, report)

    def test_comparator_wrong_routes(self):
        filesfound = []
        for file in os.listdir(self.pathreports):
            fullpath = os.path.join(self.pathreports, file)
            if os.path.isfile(fullpath):
                filesfound.append(file)

        user_input_comparator("rutanoexistenteuno", "rutanoexistentedos", closemozilla=False)

        newreports = []
        for file in os.listdir(self.pathreports):
            if file not in filesfound:
                newreports.append(file)

        self.assertEqual(len(newreports), 0)  # 0 nuevos informes

    def test_comparator_no_differences(self):
        filesfound = []
        for file in os.listdir(self.pathreports):
            fullpath = os.path.join(self.pathreports, file)
            if os.path.isfile(fullpath):
                filesfound.append(file)

        user_input_comparator(1, 1)

        newreports = []
        for file in os.listdir(self.pathreports):
            if file not in filesfound:
                newreports.append(file)

        self.assertEqual(len(newreports), 1)  # 1 nuevo informe

        file = open(os.path.join(self.pathreports, newreports[0]))
        filelines = file.readlines()
        self.assertTrue(any(line.__contains__("<h2> Host: 192.168.33.20 </h2>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>CONTENT-SECURITY-POLICY</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>X-FRAME-OPTIONS</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>X-XSS-PROTECTION</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>PUBLIC-KEY-PINS</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>X-CONTENT-TYPE-OPTIONS</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>STRICT-TRANSPORT-SECURITY</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>EXPECT-CT</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>REFERRER-POLICY</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>FEATURE-POLICY</td> ") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>SERVER</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>CONTENT-TYPE</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>DATE</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>CUSTOM-HEADER-HERE</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>OTRO-CUSTOM</td>") for line in filelines))

    def test_comparator_differences(self):
        filesfound = []
        for file in os.listdir(self.pathreports):
            fullpath = os.path.join(self.pathreports, file)
            if os.path.isfile(fullpath):
                filesfound.append(file)

        user_input_comparator(1, 5)

        newreports = []
        for file in os.listdir(self.pathreports):
            if file not in filesfound:
                newreports.append(file)

        self.assertEqual(len(newreports), 1)  # 1 nuevo informe

        file = open(os.path.join(self.pathreports, newreports[0]))
        filelines = file.readlines()
        self.assertTrue(any(line.__contains__("<tr class='before'> <th>Date</th>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr class='after'> <th>Date</th>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr class='before'> <th>Time Taken</th>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr class='after'> <th>Time Taken</th>") for line in filelines))
        self.assertTrue(any(line.__contains__("<h2> Host: 192.168.33.20 </h2>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>CONTENT-SECURITY-POLICY</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>X-FRAME-OPTIONS</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>X-XSS-PROTECTION</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>PUBLIC-KEY-PINS</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>X-CONTENT-TYPE-OPTIONS</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr class='before'> <td>STRICT-TRANSPORT-SECURITY</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>EXPECT-CT</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>REFERRER-POLICY</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr class='before'> <td>FEATURE-POLICY</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>SERVER</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>CONTENT-TYPE</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>DATE</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>CUSTOM-HEADER-HERE</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr> <td>OTRO-CUSTOM</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr class='after'> <td>NEW-CUSTOM</td>") for line in filelines))
        self.assertTrue(any(line.__contains__("<tr class='after'> <td>NEW-CUSTOM-2</td>") for line in filelines))

