import PySimpleGUI as sg
#from src.reportcomparator import ReportComparator
from src.reportcomparator import ReportComparator


def get_layout():
    reportcomparatorlayout = [[sg.Text("Select two reports to be compared")],
                              [sg.Text("Report 1:", key='-LBLFILE1-'),
                               sg.InputText(key='-ROUTEREPORT1-'),
                               sg.FileBrowse(key='-FILECMP1-',
                                             file_types=(("Text Files", "*.html"),),
                                             initial_folder="../reports")],
                              [sg.Text("Report 2:", key='-LBLFILE2-'),
                               sg.InputText(key='-ROUTEREPORT2-'),
                               sg.FileBrowse(key='-FILECMP2-',
                                             file_types=(("Text Files", "*.html"),),
                                             initial_folder="../reports")],
                              [sg.Column([[sg.Button("Compare", key='-COMPARE-')]],
                                         vertical_alignment='center',
                                         justification='center',
                                         element_justification='center',
                                         key='-COLUMN-')]]

    return reportcomparatorlayout


def launch_reportcomparator(file1, file2):
    ReportComparator.main(file1, file2)
