import PySimpleGUI as sg
#from src.scanner import NetworkScanner
from ..scanner import NetworkScanner


def get_layout():
    scanlayout = [[sg.Column([[sg.Text("Introduce a range of IP Addresses in CIDR notation:")],
                              # ip de la máquina: 192.168.33.20-22
                              [sg.Input('192.168.33.0/27', size=(40, 1), enable_events=True, key='-INPUT-')],
                              [sg.Button("Scan", key='-SCAN-')]
                              ],
                             vertical_alignment='center',
                             justification='center',
                             element_justification='center',
                             k='-C-')]]

    return scanlayout


def launch_scanner(targets):
    NetworkScanner.main(targets)
