import ast
from src.oop.Header import Header
import os


# Produces a list of expected headers in a HTTP port from a dictionary
def main():
    dirname = os.path.dirname(__file__)
    filenameheaders = os.path.join(dirname, "./standard-response-headers-mozilla.txt")
    # file = open("./standard-response-headers-mozilla.txt", "r")
    file = open(filenameheaders, "r")
    contents = file.read()
    dictionary = ast.literal_eval(contents)
    file.close()
    headerlist = []
    for key in dictionary:
        headertype = dictionary[key]["type"]
        category = dictionary[key]["category"]
        reference = dictionary[key]["reference"]
        correctvalues = dictionary[key]["correct-values"]
        headerlist.append(Header(key.upper(), None, headertype, category, reference, correctvalues, None))
    return headerlist


if __name__ == "__main__":
    main()
